/*

             ***************************************************
             ****                 VEGA V1.1                 ****
             ****  Copyright 1996-2000, Alessandro Pedretti ****
             ****  Definitions of variables and prototypes  ****
             ***************************************************


*/
#ifndef __GLOBVAR
#define  __GLOBVAR

/**** Global variables ****/

#ifndef __MAIN

extern ATMTAB   AtmTable[];
extern ATOMO    *LastAtm;
extern char     FFName[], GlobSwitch[], *VrmlHdr;
extern char     OutFile[], *ShapeType[], AATab[];
extern char     *OutFName[], *PDBAtmRec[], *VEGAHdr;
extern QCHAR    AAEquivTab[], AAResTab[];
extern PREFS    Prefs;
extern UBYTE    *MatchMtx;
extern ULONG    TotBond;

#endif


/**** Prototypes ****/

void    AddToRad(ATOMO *, float *, float);
void    *Alloca(ULONG);
ATOMO   *AllocAtm(ATOMO **, ULONG *);
float   *AssignCovRad(ATOMO *, ULONG);
float   *AssignVdwRad(ATOMO *, ULONG, float, float *);
BOOL    AssignFF(char *, ATOMO *, ULONG, BOOL);
BOOL    AtmTrans(ATOMO *, ULONG, TRJPAR *);
ULONG   AttToOrd(ATOMO *);
double  BondAngle(ATOMO *, ATOMO *, ATOMO *);
ATOMO   *CarLoad(FILE *, RECORD *, ULONG *);
void    CalcBox(ATOMO *, float *, XYZ *, XYZ *);
float   CalcDipole(ATOMO *);
BOOL    CalcEnerCVFF(FILE *, ATOMO *, ULONG, LONG, LONG);
XYZ     *CalcSfUn(ULONG, float, ULONG *);
float   CalcSrfArea(ATOMO *, float *, XYZ *, ULONG, TRJPAR *, float);
float   CalcSrfLogP(ATOMO *, float *, float, float, float);
float   CalcSrfMep(ATOMO *, float, float, float);
float   CalcVLogP(ATOMO *, float *, float, XYZ *, ULONG, float *);
float   CalcVolume(ATOMO *, float *, float, XYZ *, XYZ *);
BOOL    CarSave(FILE *, ATOMO *, WORD);
void    ChangeExt(char *, char *);
BOOL    Charge(char *, UWORD, ATOMO *, ULONG);
void    ChargeErr(char *, char *, ULONG);
BOOL    ChkCharges(ATOMO *, ULONG, float *);
BOOL    ChkForceField(ATOMO *, ULONG);
BOOL    ChkFFAtm(ATOMO *, FFDESC *);
BOOL    Connect(ATOMO *, ULONG);
ULONG   CountRes(ATOMO *);
void    CrossProd(VECTYPE *, VECTYPE *, VECTYPE *);
ATOMO   *CRDLoad(FILE *, RECORD *, ULONG *);
BOOL    CRDSave(FILE *, ATOMO *, ULONG);
ATOMO   *CSSRLoad(FILE *, RECORD *, ULONG *, UWORD);
BOOL    CSSRSave(FILE *, ATOMO *, ULONG, UWORD);
BOOL    DCDAnalyzer(char *, ATOMO *, ULONG, TRJPAR *);
BOOL    DCDRead(FILE *, ULONG, TRJPAR *, ATOMO *);
BOOL    DCDReadFrm(FILE *, ATOMO *);
float   Det2x2(float, float, float, float);
void    Disalloca(void *);
double  Dot(VECTYPE *, VECTYPE *);
BOOL    Errore(const char *, ...);
BOOL    FastaSave(FILE *, ATOMO *);
void    FFError(FFPAR *, char *);
LONG    FindRes(ATOMO *, ULONG);
ULONG   FindResPtr(ATOMO *, ATOMO **, LONG, LONG);
void    FindRing(ATOMO *);
BOOL    ForRead(FILE *, void *, ULONG);
BOOL    ForSeek(FILE *, ULONG);
void    ForStrCpy(char *, char *, ULONG);
BOOL    ForWrite(FILE *, void *, ULONG);
BOOL    Gasteiger(char *, ATOMO *, ULONG);
BOOL    GetPrefsRes(char *);
BOOL    GetPrgPath(char *);
ATOMO   *GromosLoad(FILE *, RECORD *, ULONG *);
BOOL    GromosSave(FILE *, ATOMO *, ULONG, float);
ATOMO   *IFFLoad(FILE *, ULONG, ULONG *);
BOOL    IFFSave(FILE *, ATOMO *, ULONG);
BOOL    InfoSave(FILE *, ATOMO *, ULONG);
void    InitConn(void);
ATOMO   *Loader(char *, ULONG *, ULONG);
void    LoadPrefs(char *);
BOOL    LogPCalc(ATOMO *, ULONG, float *, float *, char *, float *);
double  Magnitude(VECTYPE *);
UWORD   MatchAtm(ATOMO *, FFDESC *, FFDESC *);
ATOMO   *Mol2Load(FILE *, RECORD *, ULONG *);
BOOL    Mol2Save(FILE *, ATOMO *, ULONG, char *);
ATOMO   *MoPacArcLoad(FILE *, RECORD *, ULONG *);
BOOL    MoPacSave(FILE *, ATOMO *, ULONG, char *, char *);
ATOMO   *MsfLoad(FILE *, ULONG *);
BOOL    MsfWrite(FILE *, ATOMO *, ULONG);
void    Normalize(ATOMO *, ULONG);
void    PDBFree(ATOMO *);
ATOMO   *PDBLoad(FILE *, RECORD *, ULONG *);
BOOL    PDBSave(FILE *, ATOMO *, ULONG, WORD);
float   PlaneAngle(PLANE *, PLANE *);
float   PlaneAngAtm(ATOMO *);
void    PlaneCof(PLANE *, ATOMO *, ATOMO *, ATOMO *);
void    PointToVect(ATOMO *, VECTYPE *);
BOOL    PrintAtmErr(char *, ATOMO *);
BOOL    PrintDosErr(void);
void    PrintLoad(char *, ULONG);
void    PrintLogP(float, float);
void    PrintProg(char *);
BOOL    PrintVlogPErr(void);
void    PrintWarn(char *);
UWORD   ReadNull(FILE *, char *, UWORD);
void    RemoveAtm(ATOMO **, ATOMO **, ATOMO **);
void    RemoveH(ATOMO **, ULONG *);
void    RemoveH2O(ATOMO **, ULONG *);
void    RemoveRes(ATOMO **, ATOMO **, ATOMO **, ULONG *);
ATOMO   *RenameRes(ATOMO *, LONG);
BOOL    RenameWat(ATOMO *);
void    RenRes(ATOMO *);
void    ResConv(QCHAR *, char *);
BOOL    Saver(char *, FILEFORMAT *, ATOMO *, ULONG);
void    SetTypeRes(QCHAR *, UBYTE);
BOOL    Solvate(char *, ATOMO *, ULONG *);
BOOL    SubArg(char **, WORD, BOOL);
BOOL    Surface(FILE *, char *, ATOMO *, ULONG, ULONG, float, UWORD, float *);
void    Swap(void *);
double  SwapD(double);
float   SwapF(float);
int     SwapI(int);
void    SwapW(void *);
int     SwapWrite(FILE *, void *);
BOOL    ToDesc(FFPAR *, FFDESC *, char *);
double  Torsion(ATOMO *, ATOMO *, ATOMO *, ATOMO *);
BOOL    TrjParser(TRJPAR *);
UWORD   TypeOfMol(ATOMO *);
void    Upper(char *);
double  VectAng(VECTYPE *, VECTYPE *);
void    VectDiff(VECTYPE *, VECTYPE *, VECTYPE *);
void    VegaGetString(char *, char *, UWORD);
BOOL    VrmlSave(FILE *, ATOMO *, ULONG);
BOOL    VrmlCpkSave(FILE *, ATOMO *, ULONG);
BOOL    VrmlSolSave(FILE *, ATOMO *, ULONG);
ATOMO   *XyzLoad(FILE *, RECORD *, ULONG *);
BOOL    XyzSave(FILE *, ATOMO *);

#endif

