/*

             **************************************************
             ****            VEGA - Gromos V1.1            ****
             ****              Loader & saver              ****
             **** Copyright 1996-2000, Alessandro Pedretti ****
             **************************************************



*/

#include <ctype.h>
#include <stdio.h>
#include <string.h>

#include "globdef.h"
#include "globvar.h"


/**** Gromos Loader ****/

ATOMO *GromosLoad(FILE *IN, register RECORD *Lin, ULONG *TotAtomi)
{
  char              ResName[20], ResSeq[20];
  register ATOMO    *Atm;

  ATOMO             *InizAtm   = NULL;

  while (fgets(Lin -> Line, LINELEN, IN)) {
    if ((*Lin -> Line != '\n') && (Lin -> Hdr != *(LONG *)"END\n")) {
      if (Atm = (ATOMO *)AllocAtm(&InizAtm, TotAtomi)) {
        sscanf(Lin -> Line, "%s %s %4s %*s %f %f %f",
                 ResSeq, ResName, Atm -> Name.C,
                 &Atm -> x, &Atm -> y, &Atm -> z);
        ResConv(&Atm -> ResSeq , ResSeq);
        ResConv(&Atm -> ResName, ResName);
        Atm -> Elem.C[0] = toupper(Atm -> Name.C[0]);
        if ((Atm -> Name.C[1]) && (islower(Atm -> Name.C[1])))
          Atm -> Elem.C[1] = Atm -> Name.C[1];
      }
    }
  }
  if (Atm) {
    Atm -> Flags = 2;
    LastAtm      = Atm;
  }

  return InizAtm;
}


/**** Gromos saver ****/

BOOL GromosSave(FILE *OUT, register ATOMO *Atm, ULONG TotAtm, float Scale)
{
  BOOL		Ret = TRUE;

  if (fprintf(OUT, "%s\n" \
                   "%5d \n", VEGAHdr, TotAtm) > 0) {
    while((Ret) && (Atm)) {
      if (fprintf(OUT, "%5.4s%-4.4s  %-4.4s%5d%8.3f%8.3f%8.3f  0.0000\n",
                  Atm -> ResSeq.C, Atm -> ResName.C, Atm -> Name.C,
                  Atm -> Num, Atm -> x / Scale, Atm -> y / Scale ,
                  Atm -> z / Scale) <= 0)
        Ret = PrintDosErr();
      Atm = Atm -> Ptr;
    }

  } else Ret = PrintDosErr();

  return Ret;
}
